## efilinux 0.9

=== Makefile ===
#
# Copyright (c) 2011, Intel Corporation
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
#    * Neither the name of Intel Corporation nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

%.efi: %.so
	$(OBJCOPY) -j .text -j .sdata -j .data -j .dynamic -j .dynsym -j .rel \
		-j .rela -j .reloc --target=$(FORMAT) $*.so $@

OBJCOPY=objcopy

HOST  = $(shell $(CC) -dumpmachine | sed "s/\(-\).*$$//")
ARCH := $(shell $(CC) -dumpmachine | sed "s/\(-\).*$$//")

ifeq ($(ARCH),x86_64)
	LIBDIR=/usr/lib64
	FORMAT=efi-app-x86-64
else
	ARCH=ia32
	LIBDIR=/usr/lib
	FORMAT=efi-app-$(ARCH)
endif

CRT0 := $(LIBDIR)/gnuefi/crt0-efi-$(ARCH).o
LDSCRIPT := $(LIBDIR)/gnuefi/elf_$(ARCH)_efi.lds

CFLAGS=-I. -I/usr/include/efi -I/usr/include/efi/$(ARCH) \
		-DEFI_FUNCTION_WRAPPER -fPIC -fshort-wchar -ffreestanding \
		-Wall -Ifs/ -Iloaders/ -D$(ARCH) -Werror

ifeq ($(ARCH),ia32)
	ifeq ($(HOST),x86_64)
		CFLAGS += -m32
	endif
endif

LDFLAGS=-T $(LDSCRIPT) -Bsymbolic -shared -nostdlib -znocombreloc \
		-L$(LIBDIR) $(CRT0)

IMAGE=efilinux.efi
OBJS = entry.o malloc.o
FS = fs/fs.o

LOADERS = loaders/loader.o \
	  loaders/bzimage/bzimage.o \
	  loaders/bzimage/graphics.o

all: $(IMAGE)

efilinux.efi: efilinux.so

efilinux.so: $(OBJS) $(FS) $(LOADERS)
	$(LD) $(LDFLAGS) -o $@ $^  -lgnuefi -lefi $(shell $(CC) $(CFLAGS) -print-libgcc-file-name)

clean:
	rm -f $(IMAGE) efilinux.so $(OBJS) $(FS) $(LOADERS)

=== debian/changelog ===
efilinux (0.9-2) unstable; urgency=low

  * Adding patch to update libdir on amd64 (Closes: #646191).

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Sat, 22 Oct 2011 08:13:10 +0200

efilinux (0.9-1) unstable; urgency=low

  * Initial release (Closes: #639768).

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Wed, 12 Oct 2011 21:19:34 +0200

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh ${@}

override_dh_fixperms:
	dh_fixperms

	chmod 0644 debian/efilinux/usr/lib/efilinux/*.efi

override_dh_builddeb:
	dh_builddeb -- -Zgzip -z9

## efilinux 1.0

=== Makefile ===
--- 
+++ 
@@ -48,10 +48,13 @@
 	FORMAT=efi-app-$(ARCH)
 endif
 
-CRT0 := $(LIBDIR)/gnuefi/crt0-efi-$(ARCH).o
-LDSCRIPT := $(LIBDIR)/gnuefi/elf_$(ARCH)_efi.lds
+INCDIR := /usr/include
 
-CFLAGS=-I. -I/usr/include/efi -I/usr/include/efi/$(ARCH) \
+# gnuefi sometimes installs these under a gnuefi/ directory, and sometimes not
+CRT0 := $(shell find $(LIBDIR) -name crt0-efi-$(ARCH).o 2>/dev/null | tail -n1)
+LDSCRIPT := $(shell find $(LIBDIR) -name elf_$(ARCH)_efi.lds 2>/dev/null | tail -n1)
+
+CFLAGS=-I. -I$(INCDIR)/efi -I$(INCDIR)/efi/$(ARCH) \
 		-DEFI_FUNCTION_WRAPPER -fPIC -fshort-wchar -ffreestanding \
 		-Wall -Ifs/ -Iloaders/ -D$(ARCH) -Werror

=== debian/changelog ===
efilinux (1.0-3ubuntu1) raring; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/menu-support.patch: Add support for a boot menu.
    - debian/rules: On amd64, add a raw-uefi custom upload tarball for
      signing.
    - debian/patches/no-red-zone.patch: Pass -mno-red-zone to gcc to be
      compatible with the UEFI ABI.
    - debian/patches/files-without-drive-letters.patch: support loading
      kernels by relative path.

 -- Logan Rosen <logatronico@gmail.com>  Mon, 17 Dec 2012 16:57:34 -0500

efilinux (1.0-3) unstable; urgency=low

  * Adding dpkg-source local options.
  * Updating to standards version 3.9.4.
  * Correcting architecture fields.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Sun, 16 Dec 2012 10:38:26 +0100

efilinux (1.0-2ubuntu4) quantal; urgency=low

  * Add a version file to the raw-uefi custom upload tarball, to make it
    easier to determine the version on download without having to parse
    Apache directory listings.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 22 Aug 2012 12:34:30 +0100

efilinux (1.0-2ubuntu3) quantal; urgency=low

  * debian/patches/no-red-zone.patch: Pass -mno-red-zone to gcc to be
    compatible with the UEFI ABI.  Closes LP: #1025931.
  * debian/patches/files-without-drive-letters.patch: support loading
    kernels by relative path.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 24 Jul 2012 16:23:46 -0700

efilinux (1.0-2ubuntu2) quantal; urgency=low

  * On amd64, add a raw-uefi custom upload tarball for signing.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 19 Jul 2012 12:10:03 +0100

efilinux (1.0-2ubuntu1) quantal; urgency=low

  * debian/patches/menu-support.patch: Add support for a boot menu.
    Thanks to Colin Watson <cjwatson@canonical.com>.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 03 Jul 2012 12:11:26 -0700

efilinux (1.0-2) unstable; urgency=low

  * Switching to xz compression.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Fri, 29 Jun 2012 14:32:09 +0200

efilinux (1.0-1) unstable; urgency=low

  * Updating package to standards version 3.9.3.
  * Updating package to debhelper version 9.
  * Merging upstream version 1.0.
  * Updating copyright file to machine-readable format version 1.0.
  * Rediffing gnuefi.patch.
  * Adding lintian overrides.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Fri, 18 May 2012 14:19:00 +0200

=== debian/control ===
Source: efilinux
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Baumann <daniel.baumann@progress-technologies.net>
Build-Depends: debhelper (>= 9), gnu-efi
Standards-Version: 3.9.4

Package: efilinux
Architecture: amd64 i386
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: UEFI bootloader
 efilinux is a simple UEFI bootloader.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh ${@}

ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifeq ($(ARCH),amd64)
VERSION := $(shell LC_ALL=C dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
TARNAME := efilinux_$(VERSION)_$(ARCH).tar.gz
endif

override_dh_clean:
	dh_clean
	rm -rf debian/efilinux-images

override_dh_builddeb:
	dh_builddeb -- -Zxz -z9
ifeq ($(ARCH),amd64)
	mkdir -p debian/efilinux-images/$(VERSION)
	cp -a debian/efilinux/usr/lib/efilinux/efilinux.efi \
		debian/efilinux-images/$(VERSION)/
	echo $(VERSION) > debian/efilinux-images/$(VERSION)/version
	cd debian/efilinux-images && tar czvf ../../../$(TARNAME) .
	dpkg-distaddfile $(TARNAME) raw-uefi -
endif

override_dh_fixperms:
	dh_fixperms

	chmod 0644 debian/efilinux/usr/lib/efilinux/*.efi
